# -*- coding: utf-8 -*-
"""
Created on Mon Aug 10 09:23:54 2015

@author: Ricco
"""

#importation du module
#l'alias np lui est attribué
import numpy as np

#création manuelle d'une matrice
a = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])
print(a)

#type de la structure
print(type(a))

#type des données
print(a.dtype)

#nombre de dimension
print(a.ndim)

#nb. lignes et col
#shape est de type tuple!
print(a.shape)

#nombre total d'éléments
print(a.size)

#création et typage implicite
a = np.array([[1,2],[4,7]])
print(a.dtype)

#création et typage explicite
a = np.array([[1,2],[4,7]],dtype=float)
print(a.dtype)

#création à partir d'une séquence
#attention les dim. doivent être compatibles
a = np.arange(0,10).reshape(2,5)
print(a)

#un vecteur peut être converti en matrice
a = np.array([2.1,3.4,6.7,8.1,3.5,7.2])
print(a.shape)

b = a.reshape(3,2)
print(b.shape)
print(b)

#matrices de valeurs identiques
#ex. pour une initialisation
a = np.zeros(shape=(2,4))
print(a)

#plus généralement
a = np.full(shape=(2,4),fill_value=0.1)
print(a)

#modifier répertoire
import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/Informatique/Python/Slides/exemples/H")

#charger à partir d'un fichier
a = np.loadtxt("matrice.txt",delimiter="\t",dtype=float)
print(a)

#liste de valeurs
lst = [1.2,3.1,4.5,6.3]
print(type(lst))
#conversion à partir d'une liste
a = np.asarray(lst,dtype=float).reshape(2,2)
print(a)

#
#redimensionnement
#

#matrice de valeurs
a = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])

#ajouter une ligne
#marche pour la concaténation de matrices
b = np.array([[4.1,2.6]])
c = np.append(a,b,axis=0)
print(c)

#ajouter une colonne
d = np.array([[7.8],[6.1],[5.4]])
e = np.append(a,d,axis=1)
print(e)

#insertion
f = np.insert(a,1,b,axis=0)
print(f)

#suppression
g = np.delete(a,1,axis=0)
print(g)

#modifier la dimension d'une matrice existante
#parcourt les données lignes par ligne
h = np.resize(a,new_shape=(2,3))
print(h)

#####
#EXTRACTIONS
#####

v = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])

#toutes les valeurs
print(v)
#ou
print(v[:,:])

#accès indicé - première valeur
print(v[0,0])

#dernière valeur
print(v[v.shape[0]-1,v.shape[1]-1])

#plage d'indices contigus
print(v[0:2,:])

#extrêmes - début to 2 (non-inclus)
print(v[:2,:])

#extrêmes - 1 to fin
print(v[1:,:])

#indice négatif
print(v[-1,:])

#indices négatifs
print(v[-2:,:])

#passage par une var.intermédiaire
#indices non contigus
m = np.array([0,2],dtype=int)
print(v[m,:])

#indiçage par vecteur de booléens
#si b trop court, tout le reste est considéré False
b = np.array([True,False,True],dtype=bool)
print(v[b,:])

#ex. extraire la lignes dont la somme est la plus petite min

#calculer la somme des colonnes pour chaque ligne
s = np.sum(v,axis=1)
print(s)
b = (s == np.min(s))
print(b)
print(v[b,:])

#tris et recherche

#recherche valeur max des lignes pour chaque colonne
print(np.max(v,axis=0))

#recherche valeur max des colonnes pour chaque ligne
print(np.max(v,axis=1))


#recherche indice de valeur max des lignes pour chaque colonne
print(np.argmax(v,axis=0))

#tri des lignes pour chaque colonnes
#la relation entre les valeurs d'une même ligne est perdue
print(np.sort(v,axis=0))

#récupération des indices triés
print(np.argsort(v,axis=0))

#ITERATEUR
#parcours des matrices avec les boucles
v = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])

#boucles indicées
s = 0.0
for i in range(0,v.shape[0]):
    for j in range(0,v.shape[1]):
        print(v[i,j])
        s = s + v[i,j]
print("Somme = ",s)

#itérateur - accès ligne par ligne
s = 0.0
for x in np.nditer(v):
    print(x)
    s = s + x
print("Somme = ",s)
    
#itérateur - accès colonne par colonne
#"F" pour Fortran order
s = 0.0
for x in np.nditer(v,order="F"):
    print(x)
    s = s +x
print("Somme = ",s)
    
#itérateur fournit des outils supplémentaires
#http://docs.scipy.org/doc/numpy/reference/arrays.nditer.html

#    
#test rapidité - pas très concluant
#

#indices
def bIndices(v):
    s = 0.0
    for i in range(0,v.shape[0]):
        for j in range(0,v.shape[1]):     
            s = s + v[i,j]
    return s

#itérateur
def bIterateur(v):
    s = 0.0
    for x in np.nditer(v):
        s = s + x
    return s

v = np.random.random(1000000).reshape(1,1000000)
%timeit bIndices(v)
%timeit bIterateur(v)

#fonctions pour les calculs statistiques
#ils sont donc calculés par axe
v = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])

#moyenne des lignes pour chaque colonne
print(np.mean(v,axis=0))

#moyenne des colonnes pour chaque ligne
print(np.mean(v,axis=1))

#somme cumulée des valeurs en ligne pour chaque colonne
print(np.cumsum(v,axis=0))

#matrice de corrélation
#rowvar = 0 pour indiquer que les variables
#sont organisés en colonnes
m = np.corrcoef(v,rowvar=0)
print(m)

#################
#calcul matriciel
#################
x = np.array([[1.2,2.5],[3.2,1.8],[1.1,4.3]])
y = np.array([[2.1,0.8],[1.3,2.5]])

#transposition
print(np.transpose(x))

#multiplication
print(np.dot(x,y))

#déterminant
print(np.linalg.det(y))

#inversion
print(np.linalg.inv(y))

#résolution d'équation
z = np.array([1.7,1.0])
print(np.linalg.solve(y,z))

#vérification
print(np.dot(np.linalg.inv(y),z))

#val. etvec. propres d'une matrice symétrique
s = np.dot(np.transpose(x),x)
print(s)

print(np.linalg.eigh(s))
